use macro_rules_attribute::macro_rules_derive;
use schemars::JsonSchema;
use serde::Deserialize;

use crate::{
    macros::DefDer,
    types::traits::{
        DnsHandler,
        DnsToken,
    },
};

#[macro_rules_derive(DefDer)]
#[derive(Deserialize, JsonSchema)]
#[serde(deny_unknown_fields)]
pub struct DNSUpdateClientOptions {}

#[macro_rules_derive(DefDer)]
pub(super) struct DnsUpdateHandler {}

impl DnsHandler for DnsUpdateHandler {
    async fn set_record(&self, _domain: String, _content: String) -> crate::types::BoxedResult<dyn DnsToken> {
        Ok(Box::pin(DnsUpdateToken {}))
    }
}

#[macro_rules_derive(DefDer)]
struct DnsUpdateToken {}

impl Drop for DnsUpdateToken {
    fn drop(&mut self) {
        todo!()
    }
}
impl DnsToken for DnsUpdateToken {}
unsafe impl Send for DnsUpdateToken {}
